<?php
/*---------------------------------------------------+
| PHP-Fusion 6 Content Management System
+----------------------------------------------------+
| Copyright  2002 - 2005 Nick Jones
| http://www.php-fusion.co.uk/
+----------------------------------------------------+
| Released under the terms & conditions of v2 of the
| GNU General Public License. For details refer to
| the included gpl.txt file or visit http://gnu.org
+----------------------------------------------------*/
require_once "maincore.php";
require_once THEMES."templates/header.php";

if (file_exists(INFUSIONS."master_download_panel/locale/".$settings['locale'].".php")) {
  include INFUSIONS."master_download_panel/locale/".$settings['locale'].".php";
} else {
  include INFUSIONS."master_download_panel/locale/Polish.php";
}

// ----------------------------------------
// Konfiguracja
// ----------------------------------------
require_once INFUSIONS."master_download_panel/master_download_config.php";
require_once INFUSIONS."master_download_panel/master_download_const.php";
require_once INFUSIONS."master_download_panel/master_download_tools.php";

// ----------------------------------------
// Funkcje
// ----------------------------------------

// Bot
function isbot($agent) {
  global $mdp_bots_array;
  $result = false;
  foreach ($mdp_bots_array as $bot)
    if (!(strpos(strtolower($agent), strtolower($bot)) === false)) {
      $result = true;
      break;
      }
  return($result);
  }

// Pozycja kategorii
function make_cat($icon, $name, $desc, $noth = 0) {
  $result = "<table width='100%' border='0' cellpadding='0' cellspacing='1'>
<tr>".($noth ? "<td width='".$noth."' rowspan='".($desc ? 2 : 1)."'></td>" : "")."<td width='".(MDP_ICON_SIZE+4)."'><img src='".INFUSIONS."master_download_panel/images/".$icon."' border='0'></td><td><b>".$name."</b></td></tr>
".($desc ? "<tr><td width='".(MDP_ICON_SIZE+4)."'></td><td><span class='small'>".$desc."</span></td></tr>" : "")."</table>";
  return($result);
  }

// Pozycja podkategorii
function make_subcat($icon, $id, $name, $count, $desc, $noth = 0) {
  $result = "<table width='100%' border='0' cellpadding='0' cellspacing='1'>
<tr>".($noth ? "<td width='".$noth."' rowspan='".($desc ? 2 : 1)."'></td>" : "")."<td width='".(MDP_ICON_SIZE+4)."'><img src='".INFUSIONS."master_download_panel/images/".$icon."' border='0'></td><td><a href='".FUSION_SELF."?action=subcat&id=".$id."'>".$name."</a> <span class='small'>(".$count.")</span></td></tr>
".($desc ? "<tr><td width='".(MDP_ICON_SIZE+4)."'></td><td><span class='small'>".$desc."</span></td></tr>" : "")."</table>";
  return($result);
  }

// Komunikat
function render_message($text) {
  echo "<center><br>".$text."</center>\n";
  }

// ----------------------------------------
// Dane wejsciowe
// ----------------------------------------
if(!isset($_GET['action'])) { $_GET['action'] = ''; }
else {$_GET['action'] = cleanurl($_GET['action']); }

// ----------------------------------------
// Pobieranie
// ----------------------------------------
if (($_GET['action'] == 'get') and (isset($_GET['id']) or isset($shortcut))) {

  // Poprawnosc danych
  if (isset($_GET['id']) && !isNum($_GET['id'])) redirect(FUSION_SELF);

  // Bot
  if (isbot($_SERVER['HTTP_USER_AGENT'])) redirect(FUSION_SELF);

  // Identyfikacja pliku
  if (isset($_GET['id']))
    $file_ident = "file_id='".$_GET['id']."'";
  else
    $file_ident = "file_shortcut='".cleanurl($shortcut)."'";

  // Wyszukiwanie pliku
  $files_list = dbquery("
    SELECT file_id, file_subcat, file_shortcut, file_url, file_size, subcat_id, subcat_getaccess FROM ".$db_prefix."master_download_files
    LEFT JOIN ".$db_prefix."master_download_subcats ON ".$db_prefix."master_download_files.file_subcat=".$db_prefix."master_download_subcats.subcat_id
    WHERE ".$file_ident."
    LIMIT 1
    ");

  if (dbrows($files_list)) {

    // Dane pliku
    $file_details = dbarray($files_list);

    // Prawa dostepu
    if (checkgroup($file_details['subcat_getaccess'])) {

      $file_url = False;

      // Poprzednie pobranie
      $gets_list = dbquery("
        SELECT get_id FROM ".$db_prefix."master_download_gets
        WHERE
          get_fileid=".$file_details['file_id']." AND
          get_ip='".USER_IP."' AND
          get_date >= ".(get_sectime()-MD_FILE_COUNT_TIME_LIMIT)."
        LIMIT 1
        ");

      if (dbrows($gets_list)) {
        $get_details = dbarray($gets_list);
        $get_exists = true;
        }
      else
        $get_exists = false;

      // Dostepne mirrory
      if (dbcount("(rel_id)", "master_download_rels", "rel_fileid=".$file_details['file_id'])) {

        // Reset wykozystania transferu mirror'ow
        $ac_date = showdate("%Y.%m", get_sectime());

        $tmp_mirrors_list = dbquery("SELECT mirror_id, mirror_lastdown FROM ".$db_prefix."master_download_mirrors");
        if (dbrows($tmp_mirrors_list))
          while ($tmp_mirror_details = dbarray($tmp_mirrors_list))
            if (($tmp_mirror_details['mirror_lastdown']) and (showdate("%Y.%m", $tmp_mirror_details['mirror_lastdown']) != $ac_date))
              dbquery("UPDATE ".$db_prefix."master_download_mirrors SET mirror_used=0, mirror_lastdown=0 WHERE mirror_id=".$tmp_mirror_details['mirror_id']);

        // Lista mirrorow
        $mirrors_list = dbquery("
          SELECT mirror_id, mirror_url, rel_url,
          (mirror_used*100)/mirror_limit AS mirror_load
          FROM ".$db_prefix."master_download_mirrors
          LEFT JOIN ".$db_prefix."master_download_rels ON ".$db_prefix."master_download_rels.rel_mirrorid = ".$db_prefix."master_download_mirrors.mirror_id
          WHERE rel_fileid=".$file_details['file_id']." AND mirror_used+".$file_details['file_size']." <= mirror_limit
          ORDER BY mirror_load
          LIMIT 1
          ");

        if (dbrows($mirrors_list)) {

          // Dane mirrora
          $mirror_details = dbarray($mirrors_list);

          if (($mirror_details['rel_url']) or ($file_details['file_url'])) {

            // URL downloadu
            if (!$mirror_details['rel_url']) $mirror_details['rel_url'] = $file_details['file_url'];
            $file_url = $mirror_details['mirror_url'].$mirror_details['rel_url'];

            // Mirror
            $mirror_id = $mirror_details['mirror_id'];

            // Aktualizacja mirrora
            dbquery("
              UPDATE ".$db_prefix."master_download_mirrors
              SET
                mirror_used=mirror_used+".$file_details['file_size'].",
                mirror_lastdown=".get_sectime()."
              WHERE mirror_id=".$mirror_details['mirror_id']."
              ");

            }
          else {

            // Brak jakiejkolwiek nazwy pliku
            opentable($locale['mdp900']);
            render_message($locale['mdp935']);
            closetable();

            }

          }
        else {

          // Brak dostepnego mirror'a
          opentable($locale['mdp900']);
          render_message($locale['mdp932']);
          closetable();

          }

        }
      elseif ($file_details['file_url']) {

        // URL downloadu
        $file_url = $file_details['file_url'];

        }
      else {

        // Brak jakiejkolwiek nazwy pliku
        opentable($locale['mdp900']);
        render_message($locale['mdp935']);
        closetable();

        }

      if ($file_url !== False) {

        if ($get_exists) {

          // Aktualizacji statystyk
          dbquery("
            UPDATE ".$db_prefix."master_download_gets
            SET get_date=".get_sectime()."
            WHERE get_id=".$get_details['get_id']."
            ");

          }
        else {

          // Aktualizacja ilosci pobran
          dbquery("UPDATE ".$db_prefix."master_download_files SET file_count=file_count+1 WHERE file_id=".$file_details['file_id']);

          // Dodanie statystyk
          dbquery("
            INSERT INTO ".$db_prefix."master_download_gets
            (get_fileid, get_mirrorid, get_ip, get_agent, get_referer, get_date)
            VALUES
            (".$file_details['file_id'].", ".(isset($mirror_id) ? $mirror_id : 0).", '".USER_IP."', '".$_SERVER['HTTP_USER_AGENT']."', '".$_SERVER['HTTP_REFERER']."', ".get_sectime().")
            ");

          $get_id = mysql_insert_id();

          // Usuniecie starych statystyk
          dbquery("
            DELETE FROM ".$db_prefix."master_download_gets
            WHERE get_date < ".(get_sectime()-(MD_GETS_STATS_TIME_LIMIT*24*60*60))."
            ");

          }

        // Pobranie pliku
        redirect($file_url);

        }

      }
    else {

      // Brak praw dostepu
      opentable($locale['mdp900']);
      render_message($locale['mdp934']);
      closetable();

      }

    }
  else {

    // Brak pliku
    opentable($locale['mdp900']);
    render_message($locale['mdp933']);
    closetable();

    }

  }

// ----------------------------------------
// Pliki
// ----------------------------------------
elseif (($_GET['action'] == 'subcat') and isset($_GET['id'])) {

  // Poprawnosc danych
  if (isset($_GET['id']) && !isNum($_GET['id'])) redirect(FUSION_SELF);
  if (!isset($rowstart) or !isNum($rowstart)) $rowstart = 0;

  // Nazwa kategorii - subkategorii
  $subcats_list = dbquery("
    SELECT cat_name, subcat_name, subcat_sort
    FROM ".$db_prefix."master_download_subcats
    LEFT JOIN ".$db_prefix."master_download_cats ON ".$db_prefix."master_download_cats.cat_id=".$db_prefix."master_download_subcats.subcat_cat
    WHERE subcat_id='".$_GET['id']."' AND subcat_cat > '0' AND ".groupaccess('subcat_viewaccess')."
    LIMIT 1
    ");

  if (dbrows($subcats_list)) {

    // Dane podkategorii
    $subcat_details = dbarray($subcats_list);
    $subcat_name = $subcat_details['cat_name'].' - '.$subcat_details['subcat_name'];

    // Lista plikow
    $files_list = dbquery("
      SELECT * FROM ".$db_prefix."master_download_files
      WHERE file_subcat='".$_GET['id']."'
      ORDER BY ".$subcat_sort_array[$subcat_details['subcat_sort']][1]."
      LIMIT ".$rowstart.",".MDP_FILES_PER_PAGE_LIMIT
      );

    $files_count = dbrows($files_list);

    if ($files_count) {

      // Download
      opentable($locale['mdp900'].': '.$subcat_name);

      while ($file_details = dbarray($files_list)) {

        echo "<table width='100%' cellpadding='0' cellspacing='1' class='tbl-border'>"
        ."<tr><td colspan='4' class='forum-caption'><b>".$file_details['file_name']."</b></td></tr>"
        ."<tr><td colspan='4' class='tbl1'>".($file_details['file_img'] ? "<img src='".$file_details['file_img']."' alt='".$file_details['file_name']."' border='0' align='left' style='margin: 5px;'>" : "").$file_details['file_desc']."</td></tr>"
        ."<tr>"
        ."<td width='25%' class='tbl2'>".$locale['mdp911']." ".showdate("%d.%m.%y", $file_details['file_date'])."</td>"
        ."<td width='25%' class='tbl1'>".$locale['mdp912']." ".$file_details['file_count']."</td>"
        ."<td width='25%' class='tbl2'>".$locale['mdp913']." ".format_filesize($file_details['file_size'])."</td>"
        ."<td width='25%' class='tbl1' align='center'><a href='".make_filelink($file_details)."'>".$locale['mdp914']."</a></td>"
        ."</tr>"
        ."</table>";

        }

      closetable();

      if ($files_count > MDP_FILES_PER_PAGE_LIMIT)
        echo "<div align='center' style='margin-top:5px;'>\n".makePageNav($rowstart, MDP_FILES_PER_PAGE_LIMIT, $files_count, 3, FUSION_SELF."?action=subcat&id=".$id."&")."\n</div>\n";

      }
    else {

      // Brak plikow
      opentable($locale['mdp900'].': '.$subcat_name);
      render_message($locale['mdp931']);
      closetable();

      }

    }
  else {

    // Brak podkategorii
    opentable($locale['mdp900']);
    render_message($locale['mdp936']);
    closetable();

    }

  }

// ----------------------------------------
// Kategorie i subkategorie
// ----------------------------------------
else {

  // Lista kategorii
  $cats_list = dbquery("
    SELECT cat_id, cat_name, cat_desc FROM ".$db_prefix."master_download_cats
    ORDER BY cat_order
    ");

  if (dbrows($cats_list)) {

    // Download
    opentable($locale['mdp900']);

    echo "<table width='100%' border='0' cellpadding='0' cellspacing='0'>";

    $i = 0;
    while ($cat_details = dbarray($cats_list)) {

      // Lista podkategorii
      $subcats_list = dbquery("
        SELECT subcat_id, subcat_name, subcat_desc, subcat_count FROM ".$db_prefix."master_download_subcats
        WHERE subcat_cat='".$cat_details['cat_id']."' AND ".groupaccess('subcat_viewaccess')."
        ORDER BY subcat_order
        ");

      if (dbrows($subcats_list)) {

        // Separator poziomy
        if (($i) and ($i % 2 == 0))
          echo "<tr><td align='center'><hr width='90%'></td><td align='center'><hr width='90%'></td></tr>\n";

        // Rozpoczecie wiersza
        if ($i % 2 == 0)
          echo "<tr>";

        // Naglowek kategorii
        echo "<td width='50%' valign='top'>"
        ."<table width='100%' border='0' cellpadding='0' cellspacing='2'>"
        ."<tr><td>".make_cat('folder.gif', $cat_details['cat_name'], $cat_details['cat_desc'])."</td></tr>";

        // Naglowki podkategorii
        while ($subcat_details = dbarray($subcats_list))
          echo "<tr><td>".make_subcat('subfolder.gif', $subcat_details['subcat_id'], $subcat_details['subcat_name'], $subcat_details['subcat_count'], $subcat_details['subcat_desc'], 8)."</td></tr>";

        echo "</table>"
        ."</td>";

        // Zakonczenie wiersza
        if ($i % 2 != 0)
          echo "</tr>\n";

        $i++;

        }

      }

    // Zamkniecie tabeli
    if ($i % 2 != 0)
      echo "<td width='50%'></td></tr>";

    echo "</table>\n";

    closetable();

    }
  else {

    // Brak kategorii
    opentable($locale['mdp900']);
    render_message($locale['mdp930']);
    closetable();

    }

  }

require_once THEMES."templates/footer.php";
?>
